#ifndef __QEI_H
#define __QEI_H
//Left Wheel Encoder

union UINT_UCHAR{
		unsigned int intCount;
		unsigned char charCount[2];
};    

void initQEI(char mode){//input 2x or 4x, default 2x
	ANSEL0bits.ANS3 = 0;
	ANSEL0bits.ANS4 = 0;
	TRISA |= 0b00011000;
	if (4 == mode){
		QEICON = 0b10111000;
	}
	else{
		QEICON = 0b10101000;
	}
	POSCNTH = 0;
	POSCNTL = 0;
	MAXCNTH = 0xFF;
	MAXCNTL = 0xFF;
}

unsigned int getQEIPos(void){
	union UINT_UCHAR qeiPos;
	
	qeiPos.charCount[0] = POSCNTL;
	qeiPos.charCount[1] = POSCNTH;
	
	return qeiPos.intCount;
}

void setQEIPos(unsigned int pos){
	union UINT_UCHAR qeiPos;
	qeiPos.intCount = pos;
	POSCNTH = qeiPos.charCount[1];
	POSCNTL = qeiPos.charCount[0];
}
	
#endif
